/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"
#include <stdio.h>

#include <stdbool.h>

#define PEER_DEVICE_PSM             (84)
#define PEER_DEVICE_TX_CREDITS      (10)
#define LOCAL_DEVICE_PSM            (25)
#define LOCAL_DEVICE_MTU            (1024)
#define LOCAL_DEVICE_MPS            (1024)
#define MAX_MTU_SIZE                (512)

uint32 passkey=0;
uint32 pow1=0;
uint8 command=0;
uint32 numcompkey;

int _write(int file, char *ptr, int len)
{
int i;
file = file;
for (i = 0; i < len; i++)
{
UART_UartPutChar(*ptr++);
}
return len;


}
typedef enum
{
getpasskey=0x00,
connected, 
idle,
pendingflashwrite,
numericcomp,
L2cap,    
}customstate;
customstate presentstate=idle, paststate=idle;


typedef enum 
{
    CHANNEL_PSM_NOT_REGISTERED,
    CHANNEL_PSM_REGISTERED,
    CHANNEL_SENT_REQUEST,
    CHANNEL_CREATED
} CHANNEL_STATE;
CHANNEL_STATE channelState;

//global variables 
uint8 sendbuffer[1000];
uint8 receivebuffer[1000];
CYBLE_L2CAP_CBFC_CONN_CNF_PARAM_T  cbfcResponse;
CYBLE_L2CAP_CBFC_CONNECT_PARAM_T cbfcPeerParameters;
uint16 l2capCid;
bool previousDataTransmitted = true;
uint8 connection=0;
CYBLE_L2CAP_CBFC_RX_PARAM_T *cbfcRxParameter;
CYBLE_GATT_HANDLE_VALUE_PAIR_T		writeHandle;
uint16 longwritecount=0;
CYBLE_L2CAP_CBFC_CONNECT_PARAM_T cbfcLocalParameters = 
{
    LOCAL_DEVICE_MTU,         /* MTU size of this device */
    LOCAL_DEVICE_MPS,         /* MPS size of this device */
    PEER_DEVICE_TX_CREDITS    /* Initial Credits given to peer device for Tx */
};
volatile CYBLE_API_RESULT_T apiresult;
uint16 i=0;
uint8 sendchunk=0;
uint8 bval;
CYBLE_GATT_HANDLE_VALUE_PAIR_T  s1c1;
uint8 notificationdata[5]={0xFF,0xFF,0xFF,0xFF,0xFF};
uint8 indicationdata[5]={0xDD,0xDD,0xDD,0xDD,0xDD};
uint8 writedata[5]={0xAA, 0xAA, 0xAA, 0xAA, 0xAA};
CYBLE_GATT_HANDLE_VALUE_PAIR_T gattreaddata;
CYBLE_GATT_ERR_CODE_T errorcode;




void stack_event_handler(uint32 eventCode, void * eventParam)
{
    switch(eventCode)
    {
        CYBLE_GAP_IOCAP_T iocap;
        case CYBLE_EVT_STACK_ON:
        printf("STACK ON \r\n");
        CyBle_GappStartAdvertisement(CYBLE_ADVERTISING_FAST);
        GREEN_Write(1);
        RED_Write(1);
        BLUE_Write(0);        
        CYBLE_GAP_BD_ADDR_T myaddress;
        myaddress.type=0x00;
        for(i=0;i<6;i++)
        myaddress.bdAddr[i]=0xAA;
        CyBle_SetDeviceAddress(&myaddress);
        printf("My device address is: ");
        for(i=0;i<6;i++)
        printf("%02X ",myaddress.bdAddr[i]);
        printf("\r\n");
        iocap=CYBLE_GAP_IOCAP_NOINPUT_NOOUTPUT;
        CyBle_GapSetIoCap(iocap);
        break;
        
        
        
        case CYBLE_EVT_GAPP_ADVERTISEMENT_START_STOP:
        if(CyBle_GetState() == CYBLE_STATE_DISCONNECTED)
        {
        printf("Advertising restart\r\n");
        } 
        else if (CyBle_GetState() == CYBLE_STATE_ADVERTISING)
        printf("advertising \r\n");
        break;
        
            
            
         case CYBLE_EVT_GAP_DEVICE_CONNECTED:
         UART_UartPutString("\n\rCYBLE_EVT_GAP_DEVICE_CONNECTED\r\n ");
         //CyBle_GapAuthReq(cyBle_connHandle.bdHandle, &cyBle_authInfo);
         break;
            
            
            
            
          case CYBLE_EVT_GAP_DEVICE_DISCONNECTED:
          printf("CYBLE_EVT_GAP_DEVICE_DISCONNECTED\r\n");
          CyBle_GappStartAdvertisement(CYBLE_ADVERTISING_FAST);
          break;
            
            
        CYBLE_CONN_HANDLE_T  connHandle;
        case CYBLE_EVT_GATT_CONNECT_IND:
        printf("CYBLE_EVT_GATT_CONNECT_IND\r\n");
        connection=1;
        connHandle = *(CYBLE_CONN_HANDLE_T *)eventParam;
        printf("connection handle.attr is %d \r\n",connHandle.attId);
        printf("connection handle.bdhandle is %d \r\n",cyBle_connHandle.attId);
        CyBle_GappStopAdvertisement();
        GREEN_Write(0);
        RED_Write(1);
        BLUE_Write(1);
        UART_UartPutString("CYBLE_EVT_GATT_CONNECT_IND - Connection established. \r\n"); 
        if(CyBle_GetState() == CYBLE_STATE_ADVERTISING)
        {
        CyBle_GappStopAdvertisement ();
        UART_UartPutString("Advertisement stopped \r\n");
        }
        UART_UartPutString("\r\n");
        UART_UartPutString("\r\n");           
        if(CYBLE_ERROR_OK == CyBle_L2capCbfcRegisterPsm(LOCAL_DEVICE_PSM , 0))
           {
           channelState = CHANNEL_PSM_REGISTERED;
           UART_UartPutString("PSM registered\n\r");
           }                    
        break;
              
                    
                    
                    
        case CYBLE_EVT_GATT_DISCONNECT_IND:
        printf("CYBLE_EVT_GATT_DISCONNECT_IND \r\n");
        connection=0;
        GREEN_Write(1);
        RED_Write(0);
        BLUE_Write(1);
        channelState= CHANNEL_PSM_REGISTERED;
        break;
                    
                    

                    
                    
                    
        /* Previous data transmission completed */
        case CYBLE_EVT_L2CAP_CBFC_DATA_WRITE_IND:
        UART_UartPutString("CYBLE_EVT_L2CAP_CBFC_DATA_WRITE_IND \r\n");
        break;
            
                    
                   
        case CYBLE_EVT_L2CAP_CBFC_CONN_CNF:
            UART_UartPutString("CYBLE_EVT_L2CAP_CBFC_CONN_CNF \r\n");
            cbfcResponse = *(CYBLE_L2CAP_CBFC_CONN_CNF_PARAM_T *)eventParam;
            
            /* If the connection request was accepted */
            if(cbfcResponse.response == CYBLE_L2CAP_CONNECTION_SUCCESSFUL)
            {
                UART_UartPutString("\n\r CONN CNF confirmation received. Sending data.\r\n ");
                
                /* Cache the connection parameters and channel ID */
                cbfcPeerParameters = cbfcResponse.connParam;
                l2capCid = cbfcResponse.lCid;
                   printf("The value of l2capcid is %d \r\n", l2capCid);
                /* Update the state machine to indicate that the channel 
                 * is created.
                 */
                channelState = CHANNEL_CREATED;
                printf("channelstate is changed to CHANNEL_CREATED \r\n");
            }
            break;
         
            
            
       case CYBLE_EVT_L2CAP_CBFC_DATA_READ:
            UART_UartPutString("\r\n CYBLE_EVT_L2CAP_CBFC_DATA_READ- event triggered \r\n");
            /* New data received on the L2CAP channel */
            cbfcRxParameter = (CYBLE_L2CAP_CBFC_RX_PARAM_T *)eventParam; 
            printf("The data length is %d \r\n", cbfcRxParameter->rxDataLength);
            for (uint16 i=0;i<cbfcRxParameter->rxDataLength;i++)
            {
            printf("%d ",cbfcRxParameter->rxData[i]);
            receivebuffer[i]=cbfcRxParameter->rxData[i];
            }
            //important
            channelState = CHANNEL_CREATED;
            printf("The channel state is %d \r\n", channelState);
            printf("\r\n");
            break;
            
            
            
         /* Invalid credits received from peer device; initiate disconnect */
        case CYBLE_EVT_L2CAP_CBFC_TX_CREDIT_IND:
            UART_UartPutString("CYBLE_EVT_L2CAP_CBFC_TX_CREDIT_IND \r\n");
            if(((CYBLE_L2CAP_CBFC_LOW_TX_CREDIT_PARAM_T *)eventParam)->result != CYBLE_L2CAP_RESULT_SUCCESS)
            {
                CyBle_L2capDisconnectReq(l2capCid);
                //channelState = CHANNEL_PSM_REGISTERED;
            }
            break;
           
            
            case CYBLE_EVT_L2CAP_CBFC_RX_CREDIT_IND:
            UART_UartPutString("\r\n CYBLE_EVT_L2CAP_CBFC_RX_CREDIT_IND \r\n");
            /* Peer device exhausted its Tx credits; send more */
            CyBle_L2capCbfcSendFlowControlCredit(l2capCid, PEER_DEVICE_TX_CREDITS);
            break;
       
            
        //CLIENT WRITE DATA REQUEST    
        CYBLE_GATTS_WRITE_REQ_PARAM_T * wrReqParam;
        case CYBLE_EVT_GATTS_WRITE_REQ:        
        wrReqParam = (CYBLE_GATTS_WRITE_REQ_PARAM_T *) eventParam;
        UART_UartPutString("CYBLE_EVT_GATTS_WRITE_REQ - central initiated write request\r\n");
        printf("The data is written for the handle %04X\r\n",wrReqParam->handleValPair.attrHandle);
        printf("The data written is\r\n");
        for(uint8 i=0;i<wrReqParam->handleValPair.value.len;i++)
        printf("%02X ",wrReqParam->handleValPair.value.val[i]);
        //RESPONSE FOR WRITE REQUEST
        CyBle_GattsWriteRsp(cyBle_connHandle);      
        UART_UartPutString("\r\n");
        UART_UartPutString("\r\n");
        writeHandle.attrHandle = wrReqParam->handleValPair.attrHandle;   
        writeHandle.value.val = wrReqParam->handleValPair.value.val;
        writeHandle.value.len = wrReqParam->handleValPair.value.len;
        CyBle_GattsWriteAttributeValue(&writeHandle,0x00,&cyBle_connHandle,CYBLE_GATT_DB_PEER_INITIATED);
        break;
            
        
        //INDICATION RESPONSE EVENT
        CYBLE_CONN_HANDLE_T * indicationresp;
        case CYBLE_EVT_GATTS_HANDLE_VALUE_CNF:       
        indicationresp = (CYBLE_CONN_HANDLE_T *)eventParam;
        printf("CYBLE_EVT_GATTS_HANDLE_VALUE_CNF-indication successful \r\n");
        printf("\r\n");
        break;
        
        //CLIENT IS WRITING WITHOUT RESPONSE
        CYBLE_GATTS_WRITE_CMD_REQ_PARAM_T *writecommandreq;
        case CYBLE_EVT_GATTS_WRITE_CMD_REQ:
        writecommandreq = (CYBLE_GATTS_WRITE_CMD_REQ_PARAM_T *)eventParam;
        printf("CYBLE_EVT_GATTS_WRITE_CMD_REQ \r\n");
        printf("Write without response event\r\n");
        printf("The data written is");
        for(i=0;i<writecommandreq->handleValPair.value.len;i++)
        printf("%02X ",writecommandreq->handleValPair.value.val[i]);
        printf("\r\n");
        writecommandreq = (CYBLE_GATTS_WRITE_CMD_REQ_PARAM_T *)eventParam;
        writeHandle.attrHandle = writecommandreq->handleValPair.attrHandle;   
        writeHandle.value.val = writecommandreq->handleValPair.value.val;
        writeHandle.value.len = writecommandreq->handleValPair.value.len;
        CyBle_GattsWriteAttributeValue(&writeHandle,0x00,&cyBle_connHandle,CYBLE_GATT_DB_PEER_INITIATED);
        break;
        
        //CLIENT PERFORMING LONG READ
        CYBLE_GATTS_CHAR_VAL_READ_REQ_T *readaccessreq;
        case CYBLE_EVT_GATTS_READ_CHAR_VAL_ACCESS_REQ:
        readaccessreq = (CYBLE_GATTS_CHAR_VAL_READ_REQ_T *)eventParam;
        UART_UartPutString("CYBLE_EVT_GATTS_READ_CHAR_VAL_ACCESS_REQ\r\n");
        printf("ATTRIBUTE HANDLE IS %d \r\n", readaccessreq->attrHandle);
        break;
  
        //CLIENT PERFORMING LONG WRITE
        CYBLE_GATTS_PREP_WRITE_REQ_PARAM_T * longwriteparam;
        case CYBLE_EVT_GATTS_PREP_WRITE_REQ :
        longwriteparam = (CYBLE_GATTS_PREP_WRITE_REQ_PARAM_T *)eventParam;
        if(longwritecount==0)
        printf("CYBLE_EVT_GATTS_PREP_WRITE_REQ\r\n");
        for(uint16 i=0;i<longwriteparam->baseAddr[longwritecount].handleValuePair.value.len;i++)
        printf("%02X ",longwriteparam->baseAddr[longwritecount].handleValuePair.value.val[i]);
        printf("\r\n");
        longwritecount++;
        break;
        
        
        
        //CLIENT COMPLETED LONG WRITE
        CYBLE_GATTS_EXEC_WRITE_REQ_T * execwrresp;
        case CYBLE_EVT_GATTS_EXEC_WRITE_REQ:       
        printf("CYBLE_EVT_GATTS_EXEC_WRITE_REQ \r\n");
        execwrresp = (CYBLE_GATTS_EXEC_WRITE_REQ_T *)eventParam; 
        //printf("The data written is \r\n");
        longwritecount=0;
        break;
        
        
        //AUTHENTICATION EVENTS
        //AUTHENTICATION REQUEST FROM CENTRAL
        case CYBLE_EVT_GAP_AUTH_REQ:
        UART_UartPutString("CYBLE_EVT_GAP_AUTH_REQ - AUTHENTICATION REQUEST FROM CENTRAL\r\n");
        printf("security=0x%x, bonding=0x%x, ekeySize=0x%x, err=0x%x \r\n",(*(CYBLE_GAP_AUTH_INFO_T *)eventParam).security,(*(CYBLE_GAP_AUTH_INFO_T *)eventParam).bonding,
              (*(CYBLE_GAP_AUTH_INFO_T *)eventParam).ekeySize,
              (*(CYBLE_GAP_AUTH_INFO_T *)eventParam).authErr);
        UART_UartPutString("\r\n");
        UART_UartPutString("\r\n");
        //the authreqreply will be sent by default
        CyBle_GappAuthReqReply(cyBle_connHandle.bdHandle,&cyBle_authInfo);
        break; 
        
        
//Negotiated information
        case CYBLE_EVT_GAP_SMP_NEGOTIATED_AUTH_INFO:
        UART_UartPutString("CYBLE_EVT_GAP_SMP_NEGOTIATED_AUTH_INFO - Central negotiated\r\n");
        printf("security=0x%x, bonding=0x%x, ekeySize=0x%x, err=0x%x \r\n",(*(CYBLE_GAP_AUTH_INFO_T *)eventParam).security,(*(CYBLE_GAP_AUTH_INFO_T *)eventParam).bonding,
              (*(CYBLE_GAP_AUTH_INFO_T *)eventParam).ekeySize,
              (*(CYBLE_GAP_AUTH_INFO_T *)eventParam).authErr);
        UART_UartPutString("\r\n");
        UART_UartPutString("\r\n");
        break;
        
        
        
        
        
//Event occurs when pairing is successful
        CYBLE_GAP_AUTH_INFO_T authInfo;
        case CYBLE_EVT_GAP_AUTH_COMPLETE:
        UART_UartPutString("CYBLE_EVT_GAP_AUTH_COMPLETE - Pairing completed successfully  \r\n");
        printf("security=0x%x, bonding=0x%x, ekeySize=0x%x, err=0x%x \r\n",
              (*(CYBLE_GAP_AUTH_INFO_T *)eventParam).security,
              (*(CYBLE_GAP_AUTH_INFO_T *)eventParam).bonding,
              (*(CYBLE_GAP_AUTH_INFO_T *)eventParam).ekeySize,
              (*(CYBLE_GAP_AUTH_INFO_T *)eventParam).authErr);
        authInfo = *(CYBLE_GAP_AUTH_INFO_T *)eventParam;
                printf("AUTHENTICATION_COMPLETED:\r\n");
            
                /* Authentication status of connection after pairing process*/
                if((authInfo.security)==0x00)
                {
                    printf("No Security\r\n");
                 }   
                else if((authInfo.security)==0x01)
                {
                    printf("Security: Unauthenticated and Encryption\r\n");
                }
                else if ((authInfo.security)==0x02)
                {
                    printf("security: Authentication and Encryption\r\n");
                }
                else if((authInfo.security)==0x03)
                {
                    printf("Unauthenticated and data signing\r\n");
                }
                else if ((authInfo.security)==0x04)
                {
                    printf("Authentication and data signing\r\n");
                }               
                /*Used Bonding or not*/
                if((*(CYBLE_GAP_AUTH_INFO_T *)eventParam).bonding==CYBLE_GAP_BONDING_NONE)
                {
                    printf("Bonding: No \r\n");
                }
                else
                {
                    printf("Bonding:yes\r\n");
                }

                printf("eKeySize: 0x%x\r\n", (*(CYBLE_GAP_AUTH_INFO_T *)eventParam).ekeySize);
                printf("err: 0x%x\r\n",(*(CYBLE_GAP_AUTH_INFO_T *)eventParam).authErr);
                UART_UartPutString("\r\n");
                UART_UartPutString("\r\n");
        break;
        
        
      //Event prints the reason for authentication failure
        case CYBLE_EVT_GAP_AUTH_FAILED:       
        printf("CYBLE_EVT_GAP_AUTH_FAILED, reason- %x", *((CYBLE_GAP_AUTH_FAILED_REASON_T *)eventParam));
        switch(*((CYBLE_GAP_AUTH_FAILED_REASON_T *)eventParam))
        {
        case CYBLE_GAP_AUTH_ERROR_CONFIRM_VALUE_NOT_MATCH:
        UART_UartPutString("CONFIRM_VALUE_NOT_MATCH\r\n");
        break;                   
        case CYBLE_GAP_AUTH_ERROR_INSUFFICIENT_ENCRYPTION_KEY_SIZE:
        UART_UartPutString("INSUFFICIENT_ENCRYPTION_KEY_SIZE\r\n");
        break;                
        case CYBLE_GAP_AUTH_ERROR_UNSPECIFIED_REASON:
        UART_UartPutString("UNSPECIFIED_REASON\r\n");
        break;
        case CYBLE_GAP_AUTH_ERROR_AUTHENTICATION_TIMEOUT:
        UART_UartPutString("AUTHENTICATION_TIMEOUT\r\n");
        break;
        case CYBLE_GAP_AUTH_ERROR_LINK_DISCONNECTED:
        UART_UartPutString("LINK_DISCONNECTED\r\n");
        break;
        default:
        break;
        }
        UART_UartPutString("\r\n");
        UART_UartPutString("\r\n");
        break;

        //this event triggers to indicate user to store bonding data to flash
        case CYBLE_EVT_PENDING_FLASH_WRITE:
        printf("CYBLE_EVT_PENDING_FLASH_WRITE \r\n");
        presentstate = pendingflashwrite;
        break;
        
        
        //This event is generated once the connection is established
        case CYBLE_EVT_GAP_ENHANCE_CONN_COMPLETE:
        UART_UartPutString("CYBLE_EVT_GAP_ENHANCE_CONN_COMPLETE\r\n");
        CyBle_GapAuthReq(cyBle_connHandle.bdHandle, &cyBle_authInfo);
        printf("\r\n");
        break;
        
                    CYBLE_GAP_SMP_KEY_DIST_T KEY;
            case CYBLE_EVT_GAP_KEYINFO_EXCHNGE_CMPLT:
            /*Key Information exchange completed */


            printf("\r\n");
            printf("KEYINFO_EXCHANGE_COMPLETED\r\n");
            KEY= *(CYBLE_GAP_SMP_KEY_DIST_T *)eventParam;

            /*Print Long term Key */
            printf("Long term Key: ");
            for(uint8 j=0;j<CYBLE_GAP_SMP_LTK_SIZE;j++)
            {
               printf("%2.2X",KEY.ltkInfo[CYBLE_GAP_SMP_LTK_SIZE-j-1]);
            }


            /*Print Encrypted Diversifier*/
            printf("\r\nEncrypted Diversifier: ");

            for(uint8 j=0;j<2;j++)
            {
                printf("%2.2X",KEY.midInfo[1-j]);
            }

            /*Print Random Number*/
            printf("\r\nRandom Number:");
            for(uint8 j=2;j<CYBLE_GAP_SMP_MID_INFO_SIZE;j++)
            {
                printf("%2.2X",KEY.midInfo[CYBLE_GAP_SMP_MID_INFO_SIZE-j+1]);
            }

            /*Print Indentifier Resolving Key*/
            printf("\r\nIndentifier Resolving Key: ");
            for(uint8 j=0;j<CYBLE_GAP_SMP_IRK_SIZE;j++)
            {
                printf("%2.2X",KEY.irkInfo[CYBLE_GAP_SMP_IRK_SIZE-j-1]);
            }

            /*Print Address of peer device*/
            printf("\r\nPublic device/Static Random address: ");
            for(uint8 j=1;j<CYBLE_GAP_SMP_IDADDR_DATA_SIZE;j++)
            {
                printf("%2.2X",KEY.idAddrInfo[CYBLE_GAP_SMP_IDADDR_DATA_SIZE-j]);
            }

            /*Print Address type of peer Device*/
            printf("\r\nAddress Type:");
            if(KEY.idAddrInfo[0]==0x00)
            {
                printf("PUBLIC\r\n");
            }
            else
            {
                printf("RANDOM\r\n");
            }

            /*Print Connection Signature Resolving Key*/
            printf("\r\nConnection Signature Resolving Key: ");
            for(uint8 j=0;j<CYBLE_GAP_SMP_CSRK_SIZE;j++)
            {
                printf("%2.2X",KEY.csrkInfo[CYBLE_GAP_SMP_CSRK_SIZE-j-1]);
            }
            printf("\r\n");
            break;

            //EVENT TO ENTER PASSKEY DISPLAYED BY CENTRAL
            case CYBLE_EVT_GAP_PASSKEY_ENTRY_REQUEST:
            UART_UartPutString("CYBLE_EVT_GAP_PASSKEY_ENTRY_REQUEST - Peripheral is requested to enter passkey \r\n");
            //HANDLED IN MAIN FOR LOOP SINCE BLOCKING INSIDE EVENT HANDLER IS NOT RECOMMENDED
            presentstate = getpasskey;
            UART_UartPutString("\r\n");
            UART_UartPutString("\r\n");
            break;
            
            //EVENT TO DISPLAY PASSKEY FOR AUTHENTICATION
            case CYBLE_EVT_GAP_PASSKEY_DISPLAY_REQUEST:
            printf("CYBLE_EVT_GAP_PASSKEY_DISPLAY_REQUEST. Passkey is: %lu \r\n", *(uint32 *)eventParam);
            printf("Please enter the passkey on your Peer BLE device \r\n");
            UART_UartPutString("\r\n");
            UART_UartPutString("\r\n");
            break;
            
            
        //EVENT TO DISPLAY NUMERIC COMPARISON KEY           
        case CYBLE_EVT_GAP_NUMERIC_COMPARISON_REQUEST:
        numcompkey = *((uint32 *)eventParam);
        printf("CYBLE_EVT_GAP_NUMERIC_COMPARISON_REQUEST \r\n");
        printf("The numeric comparison key is %lu", (*(uint32 *)eventParam));
        UART_UartPutString("\r\n");
        presentstate=numericcomp;
        break;

            
        default:
        printf("Event received is %lX \r\n", eventCode);
        UART_UartPutString("\r\n");   
        break;
    }
}


//PIN INTERRUPT HANDLER
void pinhandler()
{
    printf("pin interrupt\r\n");
    Pin_1_ClearInterrupt();
    sendchunk=1;
}



//TIMER INTERRUPT HANDLER FOR BATTERY LEVEL SIMULATION
void timerhandler()
{
   if(CyBle_GetState()==CYBLE_STATE_CONNECTED)
        {
            
        CYBLE_GATT_HANDLE_VALUE_PAIR_T battery;
            battery.attrHandle = cyBle_bass[0].batteryLevelHandle;
           battery.value.len=0x01;
            battery.value.val=&bval;
            CyBle_GattsReadAttributeValue(&battery,NULL,CYBLE_GATT_DB_LOCALLY_INITIATED);
            //reloading battery to 100% when drained
            if(--bval==0)
            bval=100;
            CyBle_GattsWriteAttributeValue(&battery,0x00,NULL,CYBLE_GATT_DB_LOCALLY_INITIATED);
            
        }   
    Timer_1_ClearInterrupt(Timer_1_INTR_MASK_TC);
}






int main(void)
{
    CyGlobalIntEnable; /* Enable global interrupts. */

    /* Place your initialization/startup code here (e.g. MyInst_Start()) */
  
    isr_1_StartEx(pinhandler);
    UART_Start();
    isr_2_StartEx(timerhandler);
    Timer_1_Start();
    printf("Hello world \r\n");
    CyBle_Start(&stack_event_handler);
    
    for(i=0;i<1000;i++)
    {
    sendbuffer[i]=i;
    }
       
  
    
    
    for(;;)
    {
        CyBle_ProcessEvents();
        
        switch(presentstate)
        {
            case pendingflashwrite:
            //    if((cyBle_pendingFlashWrite != 0u) &&((UART_SpiUartGetTxBufferSize() + UART_GET_TX_FIFO_SR_VALID) == 0u))
        {
        // STORING BONDED INFORMATION TO FLASH 
        apiresult = CyBle_StoreBondingData(0u);
        if ( apiresult == CYBLE_ERROR_OK)
        {
        printf("Bonding data stored\r\n");
        printf("\r\n");
        paststate = pendingflashwrite;
        presentstate = idle;
        }
        else
        {
        printf ("Bonding data storing pending\r\n");
        }        
        }
            break;
        
        //GETTING PASSKEY FROM USER FOR AUTHENTICATION 
     case getpasskey:
     UART_UartPutString("Enter the 6 digit passkey:\r\n");   
     passkey = 0u;
     pow1 = 100000ul;
     for(i = 0u; i < CYBLE_GAP_USER_PASSKEY_SIZE; i++)
     {
     while((command = UART_UartGetChar()) == 0)
     {
     }                  
     // accept the digits that are in between the range '0' and '9'  
     if((command >= '0') && (command <= '9'))  
     {
     passkey += (uint32)(command - '0') * pow1;
     pow1 /= 10u;
     UART_UartPutChar(command); 
     }
     /* If entered digit is not in between the rnage '0' and '9'*/              
     else  
     {
     printf(" Wrong digit \r\n");
     break;
     }
     }
     CyBle_GapAuthPassKeyReply(cyBle_connHandle.bdHandle,passkey,1);
     paststate=presentstate;
     presentstate = idle;
     break;

    
    //case to enter yes or no for numeric comparison request
    char ch3=0;        
    case numericcomp:
            ch3=0;
            printf("Enter '1' to accept and '2' to reject\r\n");
            while((0u == ch3) | (ch3!='1' && ch3!='2'))
            {
            ch3=UART_UartGetChar();
            if(ch3=='1')
            {
             CyBle_GapAuthPassKeyReply(cyBle_connHandle.bdHandle, numcompkey, CYBLE_GAP_ACCEPT_PASSKEY_REQ);      
             presentstate=idle;
             paststate= numericcomp;
            ch3=0;
            break;
            }
            else if(ch3=='2')
            {
             CyBle_GapAuthPassKeyReply(cyBle_connHandle.bdHandle, numcompkey, CYBLE_GAP_REJECT_PASSKEY_REQ);   
            presentstate=idle;
            paststate= numericcomp;
            ch3=0;
            break;
            }
            else if ((ch3!='1' && ch3!='2' && ch3!=0u))
            {
            UART_UartPutString("Invalid selection. Please select your option again\r\n");
            }
            }
            break;
        
        
        case idle:
        break;
        }
        
//        switch(channelState)
//        {
//            case CHANNEL_PSM_REGISTERED:
//            if( CYBLE_ERROR_OK == CyBle_L2capCbfcConnectReq(cyBle_connHandle.bdHandle, PEER_DEVICE_PSM, LOCAL_DEVICE_PSM, &cbfcLocalParameters))                    
//                    {
//                    //printf("hello world");
//                    UART_UartPutString("\n\rL2CAP channel connection request sent. ");
//                    channelState = CHANNEL_SENT_REQUEST;
//                    }
//            break;
//                 
//                  
//            case CHANNEL_CREATED:                 
//                        if(sendchunk==1)
//                        {
//                        printf("about to send \r\n");
//                        //apiresult = CyBle_L2capChannelDataWrite(cyBle_connHandle.bdHandle, l2capCid, sendbuffer, cbfcPeerParameters.mtu);
//                        sendchunk=0;
//                        }                    
//            break;
//            
//            default :
//            break;
//        }
        
        
        /* Place your application code here. */
//        if(CyBle_GetState()==CYBLE_STATE_CONNECTED)
//        {        
//        char ch2=0; 
//        printf("\r\n");
//        printf("ENTER YOUR SELECTION \r\n");
//        printf("1. Send notification for S1_C1\r\n");
//        printf("2. Send indication for S1_C1\r\n");
//        printf("3. Read from S1_C1 (LOCAL READ)\r\n");
//        printf("4. Write to S1_C1 (LOCAL WRITE)\r\n");
//        printf("5. Send Service request\r\n");
//        printf("6. \r\n");
//        printf("7. \r\n");
//        printf("8. \r\n");
//        while((0u == ch2) | (ch2!='1' && ch2!='2' && ch2!='3' && ch2!='4' && ch2!='5' && ch2!='6' && ch2!='7' && ch2!='8' && ch2!='9'))
//        {
//        ch2=UART_UartGetChar();
//        CyBle_ProcessEvents();
//        
//        if(ch2=='1')
//        {
//        CYBLE_GATTS_HANDLE_VALUE_NTF_T ntfParam;
//        printf("You entered option 1\r\n");
//        ntfParam.attrHandle=CYBLE_S1_S1_C1_CHAR_HANDLE;
//        ntfParam.value.val = (uint8 *)notificationdata;
//        ntfParam.value.len = 0x05;
//        ntfParam.value.actualLen = 0x05;
//        CyBle_GattsWriteAttributeValue(&ntfParam,0x00,NULL,CYBLE_GATT_DB_LOCALLY_INITIATED);
//        while(CyBle_GattGetBusyStatus() != CYBLE_STACK_STATE_FREE)
//        {
//        }
//        CyBle_GattsNotification (cyBle_connHandle,&ntfParam);
//        ch2=0;
//        break;
//        }
//        
//        
//        else if( ch2=='2')
//        {
//        CYBLE_GATTS_HANDLE_VALUE_NTF_T indParam;
//        printf("You entered option 2\r\n");
//        indParam.attrHandle=CYBLE_S1_S1_C1_CHAR_HANDLE;
//        indParam.value.val = (uint8 *)indicationdata;
//        indParam.value.len = sizeof(indicationdata);
//        indParam.value.actualLen = sizeof(indicationdata);
//        CyBle_GattsWriteAttributeValue(&indParam,0x00,NULL,CYBLE_GATT_DB_LOCALLY_INITIATED);
//        while(CyBle_GattGetBusyStatus() != CYBLE_STACK_STATE_FREE)
//        {
//        }
//        CyBle_GattsIndication(cyBle_connHandle,&indParam);
//        ch2=0;
//        break;
//        }
//        
//        
//        else if( ch2=='3')
//        {
//        uint8 readdata[5];
//        printf("You entered option 3\r\n");
//        gattreaddata.attrHandle=CYBLE_S1_S1_C1_CHAR_HANDLE;
//        gattreaddata.value.len=0x05;
//        gattreaddata.value.val=readdata;
//        errorcode=CyBle_GattsReadAttributeValue(&gattreaddata, NULL, CYBLE_GATT_DB_LOCALLY_INITIATED);
//        //printf("%d\r\n",errorcode);
//        for(uint8 i=0; i<5 ;i++)
//        printf("%02X ",readdata[i]);
//        printf("\r\n");
//        ch2=0;
//        break;
//        }
//        
//        
//        else if( ch2=='4')
//        {
//        CYBLE_GATTS_HANDLE_VALUE_NTF_T writeParam;
//        printf("You entered option 4\r\n");
//        writeParam.attrHandle=CYBLE_S1_S1_C1_CHAR_HANDLE;
//        writeParam.value.val = (uint8 *)writedata;
//        writeParam.value.len = sizeof(writedata);
//        writeParam.value.actualLen = sizeof(writedata);
//        CyBle_GattsWriteAttributeValue(&writeParam,0x00,NULL,CYBLE_GATT_DB_LOCALLY_INITIATED);
//        ch2=0;
//        break;
//        }
//        
//        
//        else if( ch2=='5')
//        {
//        CyBle_GapAuthReq(cyBle_connHandle.bdHandle, &cyBle_authInfo);    
//        printf("You entered option 5\r\n");
//        ch2=0;
//        break;
//        }
//        
//        
//        else if( ch2=='6')
//        {
//        printf("You entered option 6\r\n");
//        break;
//        }
//        
//        
//        else if(ch2=='7')
//        {
//        printf("You entered option 7\r\n");       
//        ch2=0;
//        break;
//        }
//        
//        
//         else if(ch2=='8')
//         {
//         printf("You entered option 8\r\n");          
//         ch2=0;
//         break;
//        }
//        
//        
//        else if(ch2=='9')
//        {
//          printf("You entered option 9\r\n");
//          ch2=0;
//          break;
//        }
//        
//        else if ((ch2!='1' && ch2!='2' && ch2!='3' && ch2!='4' && ch2!='5' && ch2!='6' && ch2!='7' && ch2!='8' && ch2!='9' &&ch2!=0u))
//        {
//        UART_UartPutString("Invalid selection. Please select your option again\r\n");
//        }
//        } 
//        }
    }
}

/* [] END OF FILE */
